================================================================================
                                 HSPLet 更新履歴
================================================================================

2006/05/x HSPLet 3.0.2 beta 1 公開

・hwnd システム変数を実装。
・objinfo(type=2) を実装。
・パスワード入力ボックスを作成する letutil.hsp に passwordInput を追加。
・sendmsg を実装。EM_GETSEL、EM_SETSEL、EM_CANUNDO、EM_UNDO、EM_SETPASSWORDCHAR、WM_CUT、WM_COPY、WM_PASTE、WM_CLEAR

2006/05/20 HSPLet 3.0.1 公開

・負の値を文字列から数値に変換できない問題を修正。
・数値タイプの入力ボックスに -、+ 単独で入力できない問題を修正。
・hspini が対応していないブラウザのときは iniset が 1 を返すようにした。

2006/05/09 HSPLet 3.0.1 RC3 公開

・0.5 秒以上キー入力がなかったときは stick のトリガー情報を破棄するようにした。 
・sockget の挙動が hspsock.dll と異なっていたので修正。
・hspsockA の送受信命令でブロッキングするようにした。（ブロッキングしないと思ってました・・・）

2006/04/25 HSPLet 3.0.1 RC2 公開

・コンパイラ起動方法の変更。 
・テスト用メインクラス作成。 
・テスト時のURLの指定方法の変更。 

2006/04/15 HSPLet 3.0.1 RC1 公開

・テスト実行をブラウザを用いて行えるように改善。ポート 6791 で簡易 HTTP サーバーを動かします。

2006/03/27 HSPLet 3.0.1 beta 4 公開

・exgotoの動作がぜんぜん直っていなかったので修正。
・jarに含めたauファイルが再生できない問題を修正。

2006/03/26 HSPLet 3.0.1 beta 3 公開

・テスト実行時外部ブラウザをしようするようにした。
・exgotoのp1がマイナスのときの動作がHSPと互換性がなかったため修正。
・gmode/color/hsvcolor のアルファ値の範囲チェックを追加。
・grotate のサイズが省略されたときは gmode の値を使うように修正。
・exgoto の p1 が負のときの挙動が HSP と異なっていたので修正。
・u-law 形式の au サウンドを再生できるようにした。
・WEB上にアップロードするとパックファイルに入れたファイルが読み込めない問題を修正。
・存在しないファイルに対して exist を実行すると、404 レスポンスの内容のサイズを取得してしまう問題を修正。

2006/02/25 HSPLet 3.0.1 beta 2 公開

・サンプルとデモのフォルダを分けた。
・onkey の wparam の値が HSP と違うので修正。
・^、@、:、ウィンドウズキー、メニューキーが押されるとエラーで停止してしまう問題を修正。
・文字列の比較時、左の文字列が右の文字列で始まっていると、同じと判断されることがあった問題を修正。

2006/02/12 HSPLet 3.0.1 beta 1 公開

・comboxの拡張Yサイズに対応。
・hspiniプラグインを実装。
・user32.dllのうち、mod_menu.asが使用している命令だけとりあえず実装。
・oncmd命令を実装、ただし、メッセージを投げる元が user32 のメニューしかないので WM_COMMAND しか受け取れません。
　WM_KEYDOWN など、可能と思われるものは順次実装していきます。
・ユーザインターフェイスをすべて AWT ベースから Swing ベースに変更。
・ドキュメントにFAQ追加。ギャラリ・ダウンロードサイトへのリンク追加。

2006/02/12 HSPLet 3.0.0.2 公開

・inputのサイズ指定が無視されていたので修正。
・inputの文字数制限に対応。
・objprmでcomboxとlistboxの選択を変更できるようにした。
・配列変数で複数のオブジェクトの値を保持できない問題を修正。
・comboxのドロップダウンリストに不要なスクロールバーが表示されてしまう問題を修正。

2006/02/05 HSPLet 3.0.0.1 公開

・ドキュメントにlistboxの記述がかけていたので修正。
・Webにアップロードするとmidiが再生できなくなる問題を修正。
・存在しない音楽を読み込もうとすると致命的なエラーとして処理され停止してしまう問題を修正。
・画面外に対するpgetの挙動をHSPに合わせた。
・サンプルが少し寂しい気がしたので派手めのやつを入れてみた。

2006/01/30 HSPLet 3.0.0.0 公開

・getstrで改行コードの2バイト目から検索を開始したときHSPと結果が違うのでHSPに合わせた。
・strmidで文字列より長い範囲を指定するとエラーになる問題を修正。
・instrの結果が間違っていることがある問題を修正。
・int/double で文字列の前後の空白は無視するように修正。
・bufferに対してredrawするとエラーになる問題を修正。
・エラーが発生したとき無視するようにしていたが、ダイアログを出して停止するように変更。
・#deffuncのパラメータでarrayに対応
・Macではgzoomで反転しようとしたときは、gsquareを使用した反転コピーをするようにした。

2006/01/26 HSPLet 3.0 RC3 公開

・パラメータチェックを厳しくしてみた。
・付属ドキュメントにコンパイラについての説明を追加。

2006/01/23 HSPLet 3.0 RC2 公開

・gcopyの高さが常に横幅と同じになっていた問題を修正。
・clsで画面が再描画されない問題を修正。
・fontの打ち消し線と下線とアンチエイリアスに対応。
・gzoomのアンチエイリアスに対応。
・gzoom/gcopyでカレントポジションを変更しないように修正。
・ドキュメントを整備。

2006/01/21 HSPLet 3.0 RC1 公開

・画像の読み込みを ImageIO に変更。
・出力ファイル名が既存のjarとかぶっていたときはエラーメッセージを出すようにした。
・デフォルトフォントが若干小さかったようなので修正。
・rndで生成される乱数をオリジナルHSPと同じものにした。
・コンパイラの出力先にファイル名だけ書くとhsplet.jarが壊れる問題を修正しました。
・getpath、groll、memfileを実装。
・sysinfoを実装。どこまで動くかわかりませんが・・・。

2006/01/16 HSPLet 3.0 beta 12 公開

・Windows 以外でコンパイラが起動できても意味無いことに気づいたので
　コンパイラ起動用シェルスクリプトは削除。
　というかこの画面を一生懸命 Java で作ること自体無意味だったのか・・・。
・gmode 2 で、RGBすべてが0のピクセルを透過すべきところを、RGBいずれかが0のピクセルを透過してしまっていた問題を修正。
・run 命令を実装。
・exec 命令を実装、ただし HTML 表示用。
　代わりに letutil.hsp 内に定義されている showPage 命令を使用することをお勧めします。
・run 命令を実装したことによってパックファイル内に複数のクラスを含めるようになりました。
　そのためコンパイラのインターフェイスが大幅に変更になっています。
　アプレットにファイルを選択した後、開始ファイル（拡張子無し）を指定してください。（通常は自動で設定されます）
　さらに、出力する HTML と、JAR（アプレットの本体）のファイル名を指定してください。（通常は自動で設定されます）
　パックファイルの中に ax ファイルがあると自動的にコンパイルされて、アプレットとして実行できるようになります。

2006/01/14 HSPLet 3.0 beta 11 公開

・オブジェクト作成時のちらつきを防止。
・画面の描画をpaintからrepaintに変更。
・コメント記述。
・JRE 1.4で動くように変更。
　strf を使用するには hb16.jar が必要です。
　hb16.jar は非商用のみ利用可能ですので、商用アプリを作るときは
　strf を使用しないでください。

2006/01/12 HSPLet 3.0 beta 10 公開

・#deffunc で return に値を渡したときは stat に代入するようにした。
・MIDI を再生するとブラウザを閉じても鳴り続ける問題を修正。
・テスト実行中に end 命令を実行するとコンパイラごと終了してしまう問題を修正。
・コンパイラ起動用のシェルスクリプトを同封（動作未確認）。
・screen、bgscr、picload のモードを実装。
・objsel、width を実装。
・letutil.hsp を同封しました。HSPLet 上で実行中かどうかを表す onHSPLet 変数や、
　環境に依存しないフォント名 fontSerif などが定義されています。

2006/01/09 HSPLet 3.0 beta 9 公開

・ユーザ定義命令の途中の引数が省略されるとコンパイルに失敗する問題を修正。
・一度も使用されない拡張ライブラリは読み込まないようにしました。
　たとえば d3module を使用しても、 d3timer を一度も使用しなければ、winmm は必要ありません。
・getstr、noteadd、notedel、noteget、noteload、notesel、noteunsel、noteinfo、logmes を実装。
・空文字列同士の比較が行えない問題を修正。
・bload で strsize に値が返らない問題を修正。
・コンパイラに hspsock などのテスト実行に便利な「実行」ボタンをつけました。
　このボタンを使用すると、HSPLet をサーバーにおかなくても、サーバーと通信するプログラムが実行できます。

2005/12/29 HSPLet 3.0 beta 8 公開

・on 命令が含まれていると正しくコンパイルできないことがある問題を修正。

それではよいお年を〜〜（・・）ノ~~

2005/12/28 HSPLet 3.0 beta 7 公開

HDDが壊れましたが、sprocket 氏が保存しておいた beta 6 から復元することができました。
m(・・)m(_ _)mm(・・)m(_ _)mm(・・)m(_ _)mm(・・)m(_ _)mm(・・)m(_ _)m。
感謝の言葉もありません。

・winmm は別ライブラリとして外に出した（コンパイラで選択可能）。
・Opera/Firefox で表示できない問題を修正。
・コンパイラで拡張ライブラリの使用を選択できるようにした。
・コンパイラでパックファイルを使用できるようにした。
・ネットワークストリームを閉じてないせいで曲の再生が不安定だった問題を修正。
・gsquare の右端が画面からはみ出るときクリッピングがおかしい問題を修正。
・元画像が小さい gsquare の画質を向上。
・dirlist は stat に 1 を返すように修正。
・mp3 以外の音楽が再生できない問題を修正。
・hspsock/hspsockA を実装。（hspsock は未テスト）
・サンプルをサンプルらしいものに修正。
・拡張ライブラリ呼び出しをstatic以外にも対応することで状態を保持できるようにした。

2005/12/20 HSPLet 3.0 beta 6 公開

・パックファイルから読むときはフォルダ名を無視するようにした。

2005/12/19 HSPLet 3.0 beta 5 公開

・簡単なドキュメントを作成しました。
・コンパイラでアプレットサイズを指定できるようになりました。
・ラベル周りのコンパイラのバグを修正。

2005/12/18 HSPLet 3.0 beta 4 公開

・マウス入力を受け付けなくなっていた問題を修正。
・AU/WAVE/AIFF/MIDI/MP3 の再生を実装。
・mp3を再生したいときはコンパイラの当該オプションにチェックを入れ、jl1.0.jar を hsplet.jar と同じフォルダにおいてください。

2005/12/17 HSPLet 3.0 beta 3 公開

・サイズ節約のため front_end.exe を C++ で書き直しました。
・巨大なソースのコンパイルをさらに改善。
・exgoto を実装、これでforなどのマクロが機能する・・・はず・・・もちろん試してません。
・小さな整数同士の演算を高速化。

2005/12/16 HSPLet 3.0 beta 2 公開

・バイトコードの生成に巨大な BCEL を使うのをやめて小さな ASM を使うことにしました。
・button/input などのコントロール系を実装しました。
・巨大なソースは複数のメソッドに分割してコンパイルするようにしました。

2005/12/14 HSPLet 3.0 beta 1 公開

・グラフィック周りを優先的に実装したものを公開しました。
・Net-Ball、ナノ花、ルービックキューブ、ぐるぐる・ジンバルなど多くのミニゲームは現時点で動作します。
